    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2007, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -----------------
    028     * ImageEncoder.java
    029     * -----------------
    030     * (C) Copyright 2004-2007, by Richard Atkinson and Contributors.
    031     *
    032     * Original Author:  Richard Atkinson;
    033     * Contributor(s):   -;
    034     *
    035     * $Id: ImageEncoder.java,v 1.3.2.3 2007/02/02 14:51:22 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 01-Aug-2004 : Initial version (RA);
    040     * 02-Feb-2007 : Removed author tags all over JFreeChart sources (DG);
    041     *
    042     */
    043
    044    package org.jfree.chart.encoders;
    045
    046    import java.awt.image.BufferedImage;
    047    import java.io.IOException;
    048    import java.io.OutputStream;
    049
    050    /**
    051     * Interface for abstracting different types of image encoders.
    052     */
    053    public interface ImageEncoder {
    054
    055        /**
    056         * Encodes an image in a particular format.
    057         *
    058         * @param bufferedImage  The image to be encoded.
    059         *
    060         * @return The byte[] that is the encoded image.
    061         *
    062         * @throws IOException
    063         */
    064        public byte[] encode(BufferedImage bufferedImage) throws IOException;
    065
    066
    067        /**
    068         * Encodes an image in a particular format and writes it to an OutputStream.
    069         *
    070         * @param bufferedImage  The image to be encoded.
    071         * @param outputStream  The OutputStream to write the encoded image to.
    072         * @throws IOException
    073         */
    074        public void encode(BufferedImage bufferedImage, OutputStream outputStream)
    075            throws IOException;
    076
    077        /**
    078         * Get the quality of the image encoding.
    079         *
    080         * @return A float representing the quality.
    081         */
    082        public float getQuality();
    083
    084        /**
    085         * Set the quality of the image encoding (not supported by all
    086         * ImageEncoders).
    087         *
    088         * @param quality  A float representing the quality.
    089         */
    090        public void setQuality(float quality);
    091
    092        /**
    093         * Get whether the encoder should encode alpha transparency.
    094         *
    095         * @return Whether the encoder is encoding alpha transparency.
    096         */
    097        public boolean isEncodingAlpha();
    098
    099        /**
    100         * Set whether the encoder should encode alpha transparency (not
    101         * supported by all ImageEncoders).
    102         *
    103         * @param encodingAlpha  Whether the encoder should encode alpha
    104         *                       transparency.
    105         */
    106        public void setEncodingAlpha(boolean encodingAlpha);
    107
    108    }